/* Copyright (C) 1989, 1995, 1996, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This file is part of AFPL Ghostscript.
  
  AFPL Ghostscript is distributed with NO WARRANTY OF ANY KIND.  No author or
  distributor accepts any responsibility for the consequences of using it, or
  for whether it serves any particular purpose or works at all, unless he or
  she says so in writing.  Refer to the Aladdin Free Public License (the
  "License") for full details.
  
  Every copy of AFPL Ghostscript must include a copy of the License, normally
  in a plain ASCII text file named PUBLIC.  The License grants you the right
  to copy, modify and redistribute AFPL Ghostscript, but only under certain
  conditions described in the License.  Among other things, the License
  requires that the copyright notice and this notice be preserved on all
  copies.
*/

/*$Id: gxplugin.h,v 1.0 2000/09/19 19:00:32 lpd Exp $ */
/* Plugin handler for graphics library */

#include "gsplugin.h"

#ifndef gs_instance_DEFINED
#  define gs_instance_DEFINED
typedef struct gs_instance_s gs_instance;
#endif

typedef gs_plugin_retcode (*gs_plugin_registration_callback) (P2(void *client_data, gs_plugin_interface *I));

/* Exposed for gxlib clients : */

/* The most useful high-level function - loads plugin DLLs and registers them. */
gs_plugin_retcode gs_load_plugins(P4(gs_instance *gli, gs_memory_t *mem, const char *dir_path, void *client_id));

/* This function is useful if client loads plugin DLL itself. */
gs_plugin_retcode gs_register_plugin_set(P3(gs_instance *gli, PFN_get_factories gf, void *client_id));

/* This function allows for client to register a statically linked plugin. */
gs_plugin_retcode gs_register_plugin(P4(gs_instance *gli, gs_plugin_interface *I0, const char *interface_type, void *client_id));

/* This function unregisters and releases all interfaces, requested by a clien : */
gs_plugin_retcode gs_unregister_plugin_client(P2(gs_instance *gli, void *client_id));



/* Communications within graphics library : */

/* retrives set of plugin interfaces, registered with graphics library : */
gs_plugin_interface ** gs_get_installed_plugins(P1(gs_instance *gli));
gs_plugin_retcode gs_unregister_gxlib_as_plugin_client(P1(gs_instance *gli));



/* Functions useful for both gxlib and its clients : */

/* Tells to plugin manager, which interfaces to be obtained from plugins,
   and stecifies callback for their registration : */
gs_plugin_retcode gs_add_plugin_registration_request(P7(gs_instance *gli, int version_major, char *interface_type, void *client_id, void *client_data, gs_plugin_registration_callback do_register, gs_plugin_registration_callback unregister));


